-- DOS Executable Header
-- (c) FSC, 2007

local IMAGE_DOS_SIGNATURE = 0x5A4D

local _IMAGE_DOS_HEADER = function()
    TypeWidth = 5
    NameWidth = 11

    if PeekUI16() ~= IMAGE_DOS_SIGNATURE then
        Warning = "should be 'MZ'"
	WarningBox("This is not a 'MZ' file")
    end

    Char()
        WORD("e_magic", "Magic number")

    Dec()
        WORD("e_cblp", "Bytes on last page of file")
        WORD("e_cp", "Pages in file")
        WORD("e_crlc", "Relocations")
        WORD("e_cparhdr", "Size of header in paragraphs")
        WORD("e_minalloc", "Minimum extra paragraphs needed")
        WORD("e_maxalloc", "Maximum extra paragraphs needed")

    Hex()
        WORD("e_ss", "Initial (relative) SS value")
        WORD("e_sp", "Initial SP value")
        WORD("e_csum", "Checksum")
        WORD("e_ip", "Initial IP value")
        WORD("e_cs", "Initial (relative) CS value")
        WORD("e_lfarlc", "File address of relocation table")

    Dec()
        WORD("e_ovno", "Overlay number")
        WORD("e_res", "Reserved words", 4)
        WORD("e_oemid", "OEM identifier (for e_oeminfo)")
        WORD("e_oeminfo", "OEM information; e_oemid specific")
        WORD("e_res2", "Reserved words", 10)

    Hex()
        local LFANew = PeekUI32()
        LONG("e_lfanew", "File address of new exe header")
    return LFANew
end

IMAGE_DOS_HEADER = struct("IMAGE_DOS_HEADER", _IMAGE_DOS_HEADER);
